/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAnimationEffectTiming.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMWrapperCache.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>
#include <wtf/Variant.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsAnimationEffectTimingConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSAnimationEffectTimingConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsAnimationEffectTimingDuration(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSAnimationEffectTimingDuration(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);

class JSAnimationEffectTimingPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSAnimationEffectTimingPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAnimationEffectTimingPrototype* ptr = new (NotNull, JSC::allocateCell<JSAnimationEffectTimingPrototype>(vm.heap)) JSAnimationEffectTimingPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAnimationEffectTimingPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSAnimationEffectTimingConstructor = JSDOMConstructorNotConstructable<JSAnimationEffectTiming>;

template<> JSValue JSAnimationEffectTimingConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSAnimationEffectTimingConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSAnimationEffectTiming::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("AnimationEffectTiming"))), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSAnimationEffectTimingConstructor::s_info = { "AnimationEffectTiming", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationEffectTimingConstructor) };

/* Hash table for prototype */

static const HashTableValue JSAnimationEffectTimingPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAnimationEffectTimingConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAnimationEffectTimingConstructor) } },
    { "duration", static_cast<unsigned>(JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAnimationEffectTimingDuration), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAnimationEffectTimingDuration) } },
};

const ClassInfo JSAnimationEffectTimingPrototype::s_info = { "AnimationEffectTimingPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationEffectTimingPrototype) };

void JSAnimationEffectTimingPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSAnimationEffectTiming::info(), JSAnimationEffectTimingPrototypeTableValues, *this);
}

const ClassInfo JSAnimationEffectTiming::s_info = { "AnimationEffectTiming", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAnimationEffectTiming) };

JSAnimationEffectTiming::JSAnimationEffectTiming(Structure* structure, JSDOMGlobalObject& globalObject, Ref<AnimationEffectTiming>&& impl)
    : JSDOMWrapper<AnimationEffectTiming>(structure, globalObject, WTFMove(impl))
{
}

void JSAnimationEffectTiming::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSAnimationEffectTiming::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSAnimationEffectTimingPrototype::create(vm, &globalObject, JSAnimationEffectTimingPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSAnimationEffectTiming::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSAnimationEffectTiming>(vm, globalObject);
}

JSValue JSAnimationEffectTiming::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSAnimationEffectTimingConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSAnimationEffectTiming::destroy(JSC::JSCell* cell)
{
    JSAnimationEffectTiming* thisObject = static_cast<JSAnimationEffectTiming*>(cell);
    thisObject->JSAnimationEffectTiming::~JSAnimationEffectTiming();
}

template<> inline JSAnimationEffectTiming* IDLAttribute<JSAnimationEffectTiming>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSAnimationEffectTiming*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsAnimationEffectTimingConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSAnimationEffectTimingPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSAnimationEffectTiming::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSAnimationEffectTimingConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSAnimationEffectTimingPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsAnimationEffectTimingDurationGetter(ExecState& state, JSAnimationEffectTiming& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLUnion<IDLUnrestrictedDouble, IDLDOMString>>(state, *thisObject.globalObject(), throwScope, impl.bindingsDuration());
    return result;
}

EncodedJSValue jsAnimationEffectTimingDuration(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSAnimationEffectTiming>::get<jsAnimationEffectTimingDurationGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "duration");
}

static inline bool setJSAnimationEffectTimingDurationSetter(ExecState& state, JSAnimationEffectTiming& thisObject, JSValue value, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    auto& impl = thisObject.wrapped();
    auto nativeValue = convert<IDLUnion<IDLUnrestrictedDouble, IDLDOMString>>(state, value);
    RETURN_IF_EXCEPTION(throwScope, false);
    AttributeSetter::call(state, throwScope, [&] {
        return impl.setBindingsDuration(WTFMove(nativeValue));
    });
    return true;
}

bool setJSAnimationEffectTimingDuration(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    return IDLAttribute<JSAnimationEffectTiming>::set<setJSAnimationEffectTimingDurationSetter>(*state, thisValue, encodedValue, "duration");
}

bool JSAnimationEffectTimingOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSAnimationEffectTimingOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsAnimationEffectTiming = static_cast<JSAnimationEffectTiming*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsAnimationEffectTiming->wrapped(), jsAnimationEffectTiming);
}

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<AnimationEffectTiming>&& impl)
{
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to AnimationEffectTiming.
    static_assert(!std::is_polymorphic<AnimationEffectTiming>::value, "AnimationEffectTiming is polymorphic but the IDL claims it is not");
    return createWrapper<AnimationEffectTiming>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, AnimationEffectTiming& impl)
{
    return wrap(state, globalObject, impl);
}

AnimationEffectTiming* JSAnimationEffectTiming::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSAnimationEffectTiming*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
