/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAudioConfiguration.h"

#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include <runtime/JSCInlines.h>


namespace WebCore {
using namespace JSC;

template<> AudioConfiguration convertDictionary<AudioConfiguration>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    AudioConfiguration result;
    JSValue bitrateValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "bitrate"));
    if (!bitrateValue.isUndefined()) {
        result.bitrate = convert<IDLUnsignedLongLong>(state, bitrateValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue channelsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "channels"));
    if (!channelsValue.isUndefined()) {
        result.channels = convert<IDLDOMString>(state, channelsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue contentTypeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "contentType"));
    if (!contentTypeValue.isUndefined()) {
        result.contentType = convert<IDLDOMString>(state, contentTypeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "contentType", "AudioConfiguration", "DOMString");
        return { };
    }
    JSValue samplerateValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "samplerate"));
    if (!samplerateValue.isUndefined()) {
        result.samplerate = convert<IDLUnsignedLong>(state, samplerateValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

} // namespace WebCore
