/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAuthenticatorAttestationResponse.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMWrapperCache.h"
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsAuthenticatorAttestationResponseConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSAuthenticatorAttestationResponseConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsAuthenticatorAttestationResponseAttestationObject(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSAuthenticatorAttestationResponsePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSAuthenticatorAttestationResponsePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAuthenticatorAttestationResponsePrototype* ptr = new (NotNull, JSC::allocateCell<JSAuthenticatorAttestationResponsePrototype>(vm.heap)) JSAuthenticatorAttestationResponsePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAuthenticatorAttestationResponsePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSAuthenticatorAttestationResponseConstructor = JSDOMConstructorNotConstructable<JSAuthenticatorAttestationResponse>;

template<> JSValue JSAuthenticatorAttestationResponseConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    return JSAuthenticatorResponse::getConstructor(vm, &globalObject);
}

template<> void JSAuthenticatorAttestationResponseConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSAuthenticatorAttestationResponse::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("AuthenticatorAttestationResponse"))), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSAuthenticatorAttestationResponseConstructor::s_info = { "AuthenticatorAttestationResponse", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAuthenticatorAttestationResponseConstructor) };

/* Hash table for prototype */

static const HashTableValue JSAuthenticatorAttestationResponsePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAuthenticatorAttestationResponseConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAuthenticatorAttestationResponseConstructor) } },
    { "attestationObject", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAuthenticatorAttestationResponseAttestationObject), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSAuthenticatorAttestationResponsePrototype::s_info = { "AuthenticatorAttestationResponsePrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAuthenticatorAttestationResponsePrototype) };

void JSAuthenticatorAttestationResponsePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSAuthenticatorAttestationResponse::info(), JSAuthenticatorAttestationResponsePrototypeTableValues, *this);
}

const ClassInfo JSAuthenticatorAttestationResponse::s_info = { "AuthenticatorAttestationResponse", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAuthenticatorAttestationResponse) };

JSAuthenticatorAttestationResponse::JSAuthenticatorAttestationResponse(Structure* structure, JSDOMGlobalObject& globalObject, Ref<AuthenticatorAttestationResponse>&& impl)
    : JSAuthenticatorResponse(structure, globalObject, WTFMove(impl))
{
}

void JSAuthenticatorAttestationResponse::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSAuthenticatorAttestationResponse::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSAuthenticatorAttestationResponsePrototype::create(vm, &globalObject, JSAuthenticatorAttestationResponsePrototype::createStructure(vm, &globalObject, JSAuthenticatorResponse::prototype(vm, globalObject)));
}

JSObject* JSAuthenticatorAttestationResponse::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSAuthenticatorAttestationResponse>(vm, globalObject);
}

JSValue JSAuthenticatorAttestationResponse::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSAuthenticatorAttestationResponseConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

template<> inline JSAuthenticatorAttestationResponse* IDLAttribute<JSAuthenticatorAttestationResponse>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSAuthenticatorAttestationResponse*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsAuthenticatorAttestationResponseConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSAuthenticatorAttestationResponsePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSAuthenticatorAttestationResponse::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSAuthenticatorAttestationResponseConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSAuthenticatorAttestationResponsePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsAuthenticatorAttestationResponseAttestationObjectGetter(ExecState& state, JSAuthenticatorAttestationResponse& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLArrayBuffer>(state, *thisObject.globalObject(), throwScope, impl.attestationObject());
    return result;
}

EncodedJSValue jsAuthenticatorAttestationResponseAttestationObject(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSAuthenticatorAttestationResponse>::get<jsAuthenticatorAttestationResponseAttestationObjectGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "attestationObject");
}


}
