/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSAuthenticatorResponse.h"

#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMWrapperCache.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>


namespace WebCore {
using namespace JSC;

// Attributes

JSC::EncodedJSValue jsAuthenticatorResponseConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSAuthenticatorResponseConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsAuthenticatorResponseClientDataJSON(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSAuthenticatorResponsePrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSAuthenticatorResponsePrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSAuthenticatorResponsePrototype* ptr = new (NotNull, JSC::allocateCell<JSAuthenticatorResponsePrototype>(vm.heap)) JSAuthenticatorResponsePrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSAuthenticatorResponsePrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSAuthenticatorResponseConstructor = JSDOMConstructorNotConstructable<JSAuthenticatorResponse>;

template<> JSValue JSAuthenticatorResponseConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSAuthenticatorResponseConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSAuthenticatorResponse::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("AuthenticatorResponse"))), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
}

template<> const ClassInfo JSAuthenticatorResponseConstructor::s_info = { "AuthenticatorResponse", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAuthenticatorResponseConstructor) };

/* Hash table for prototype */

static const HashTableValue JSAuthenticatorResponsePrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAuthenticatorResponseConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSAuthenticatorResponseConstructor) } },
    { "clientDataJSON", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsAuthenticatorResponseClientDataJSON), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
};

const ClassInfo JSAuthenticatorResponsePrototype::s_info = { "AuthenticatorResponsePrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAuthenticatorResponsePrototype) };

void JSAuthenticatorResponsePrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSAuthenticatorResponse::info(), JSAuthenticatorResponsePrototypeTableValues, *this);
}

const ClassInfo JSAuthenticatorResponse::s_info = { "AuthenticatorResponse", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSAuthenticatorResponse) };

JSAuthenticatorResponse::JSAuthenticatorResponse(Structure* structure, JSDOMGlobalObject& globalObject, Ref<AuthenticatorResponse>&& impl)
    : JSDOMWrapper<AuthenticatorResponse>(structure, globalObject, WTFMove(impl))
{
}

void JSAuthenticatorResponse::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSAuthenticatorResponse::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSAuthenticatorResponsePrototype::create(vm, &globalObject, JSAuthenticatorResponsePrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSAuthenticatorResponse::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSAuthenticatorResponse>(vm, globalObject);
}

JSValue JSAuthenticatorResponse::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSAuthenticatorResponseConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSAuthenticatorResponse::destroy(JSC::JSCell* cell)
{
    JSAuthenticatorResponse* thisObject = static_cast<JSAuthenticatorResponse*>(cell);
    thisObject->JSAuthenticatorResponse::~JSAuthenticatorResponse();
}

template<> inline JSAuthenticatorResponse* IDLAttribute<JSAuthenticatorResponse>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSAuthenticatorResponse*>(state.vm(), JSValue::decode(thisValue));
}

EncodedJSValue jsAuthenticatorResponseConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSAuthenticatorResponsePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSAuthenticatorResponse::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSAuthenticatorResponseConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSAuthenticatorResponsePrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsAuthenticatorResponseClientDataJSONGetter(ExecState& state, JSAuthenticatorResponse& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLArrayBuffer>(state, *thisObject.globalObject(), throwScope, impl.clientDataJSON());
    return result;
}

EncodedJSValue jsAuthenticatorResponseClientDataJSON(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSAuthenticatorResponse>::get<jsAuthenticatorResponseClientDataJSONGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "clientDataJSON");
}

bool JSAuthenticatorResponseOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSAuthenticatorResponseOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsAuthenticatorResponse = static_cast<JSAuthenticatorResponse*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsAuthenticatorResponse->wrapped(), jsAuthenticatorResponse);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7AuthenticatorResponse@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore21AuthenticatorResponseE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<AuthenticatorResponse>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7AuthenticatorResponse@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore21AuthenticatorResponseE[2];
#endif

    // If this fails AuthenticatorResponse does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<AuthenticatorResponse>::value, "AuthenticatorResponse is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // AuthenticatorResponse has subclasses. If AuthenticatorResponse has subclasses that get passed
    // to toJS() we currently require AuthenticatorResponse you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<AuthenticatorResponse>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, AuthenticatorResponse& impl)
{
    return wrap(state, globalObject, impl);
}

AuthenticatorResponse* JSAuthenticatorResponse::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSAuthenticatorResponse*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
