/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSKeyframeAnimationOptions.h"

#include "JSCompositeOperation.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSFillMode.h"
#include "JSIterationCompositeOperation.h"
#include "JSPlaybackDirection.h"
#include <runtime/JSCInlines.h>
#include <wtf/Variant.h>


namespace WebCore {
using namespace JSC;

template<> KeyframeAnimationOptions convertDictionary<KeyframeAnimationOptions>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    KeyframeAnimationOptions result;
    JSValue delayValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "delay"));
    if (!delayValue.isUndefined()) {
        result.delay = convert<IDLDouble>(state, delayValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.delay = 0;
    JSValue directionValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "direction"));
    if (!directionValue.isUndefined()) {
        result.direction = convert<IDLEnumeration<PlaybackDirection>>(state, directionValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.direction = PlaybackDirection::Normal;
    JSValue durationValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "duration"));
    if (!durationValue.isUndefined()) {
        result.duration = convert<IDLUnion<IDLUnrestrictedDouble, IDLDOMString>>(state, durationValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.duration = "auto";
    JSValue easingValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "easing"));
    if (!easingValue.isUndefined()) {
        result.easing = convert<IDLDOMString>(state, easingValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.easing = ASCIILiteral("linear");
    JSValue endDelayValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "endDelay"));
    if (!endDelayValue.isUndefined()) {
        result.endDelay = convert<IDLDouble>(state, endDelayValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.endDelay = 0;
    JSValue fillValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "fill"));
    if (!fillValue.isUndefined()) {
        result.fill = convert<IDLEnumeration<FillMode>>(state, fillValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.fill = FillMode::Auto;
    JSValue iterationStartValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "iterationStart"));
    if (!iterationStartValue.isUndefined()) {
        result.iterationStart = convert<IDLDouble>(state, iterationStartValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.iterationStart = 0.0;
    JSValue iterationsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "iterations"));
    if (!iterationsValue.isUndefined()) {
        result.iterations = convert<IDLUnrestrictedDouble>(state, iterationsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.iterations = 1.0;
    JSValue compositeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "composite"));
    if (!compositeValue.isUndefined()) {
        result.composite = convert<IDLEnumeration<CompositeOperation>>(state, compositeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.composite = CompositeOperation::Replace;
    JSValue iterationCompositeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "iterationComposite"));
    if (!iterationCompositeValue.isUndefined()) {
        result.iterationComposite = convert<IDLEnumeration<IterationCompositeOperation>>(state, iterationCompositeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.iterationComposite = IterationCompositeOperation::Replace;
    JSValue idValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "id"));
    if (!idValue.isUndefined()) {
        result.id = convert<IDLDOMString>(state, idValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.id = emptyString();
    return result;
}

} // namespace WebCore
