/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSPublicKeyCredential.h"

#include "JSAuthenticatorResponse.h"
#include "JSDOMAttribute.h"
#include "JSDOMBinding.h"
#include "JSDOMConstructorNotConstructable.h"
#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMExceptionHandling.h"
#include "JSDOMGlobalObject.h"
#include "JSDOMOperation.h"
#include "JSDOMOperationReturningPromise.h"
#include "JSDOMWrapperCache.h"
#include <runtime/FunctionPrototype.h>
#include <runtime/JSCInlines.h>
#include <wtf/GetPtr.h>


namespace WebCore {
using namespace JSC;

// Functions

JSC::EncodedJSValue JSC_HOST_CALL jsPublicKeyCredentialPrototypeFunctionGetClientExtensionResults(JSC::ExecState*);
JSC::EncodedJSValue JSC_HOST_CALL jsPublicKeyCredentialConstructorFunctionIsUserVerifyingPlatformAuthenticatorAvailable(JSC::ExecState*);

// Attributes

JSC::EncodedJSValue jsPublicKeyCredentialConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
bool setJSPublicKeyCredentialConstructor(JSC::ExecState*, JSC::EncodedJSValue, JSC::EncodedJSValue);
JSC::EncodedJSValue jsPublicKeyCredentialRawId(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);
JSC::EncodedJSValue jsPublicKeyCredentialResponse(JSC::ExecState*, JSC::EncodedJSValue, JSC::PropertyName);

class JSPublicKeyCredentialPrototype : public JSC::JSNonFinalObject {
public:
    using Base = JSC::JSNonFinalObject;
    static JSPublicKeyCredentialPrototype* create(JSC::VM& vm, JSDOMGlobalObject* globalObject, JSC::Structure* structure)
    {
        JSPublicKeyCredentialPrototype* ptr = new (NotNull, JSC::allocateCell<JSPublicKeyCredentialPrototype>(vm.heap)) JSPublicKeyCredentialPrototype(vm, globalObject, structure);
        ptr->finishCreation(vm);
        return ptr;
    }

    DECLARE_INFO;
    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

private:
    JSPublicKeyCredentialPrototype(JSC::VM& vm, JSC::JSGlobalObject*, JSC::Structure* structure)
        : JSC::JSNonFinalObject(vm, structure)
    {
    }

    void finishCreation(JSC::VM&);
};

using JSPublicKeyCredentialConstructor = JSDOMConstructorNotConstructable<JSPublicKeyCredential>;

/* Hash table for constructor */

static const HashTableValue JSPublicKeyCredentialConstructorTableValues[] =
{
    { "isUserVerifyingPlatformAuthenticatorAvailable", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsPublicKeyCredentialConstructorFunctionIsUserVerifyingPlatformAuthenticatorAvailable), (intptr_t) (0) } },
};

template<> JSValue JSPublicKeyCredentialConstructor::prototypeForStructure(JSC::VM& vm, const JSDOMGlobalObject& globalObject)
{
    UNUSED_PARAM(vm);
    return globalObject.functionPrototype();
}

template<> void JSPublicKeyCredentialConstructor::initializeProperties(VM& vm, JSDOMGlobalObject& globalObject)
{
    putDirect(vm, vm.propertyNames->prototype, JSPublicKeyCredential::prototype(vm, globalObject), JSC::PropertyAttribute::DontDelete | JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->name, jsNontrivialString(&vm, String(ASCIILiteral("PublicKeyCredential"))), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::DontEnum);
    reifyStaticProperties(vm, JSPublicKeyCredential::info(), JSPublicKeyCredentialConstructorTableValues, *this);
}

template<> const ClassInfo JSPublicKeyCredentialConstructor::s_info = { "PublicKeyCredential", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPublicKeyCredentialConstructor) };

/* Hash table for prototype */

static const HashTableValue JSPublicKeyCredentialPrototypeTableValues[] =
{
    { "constructor", static_cast<unsigned>(JSC::PropertyAttribute::DontEnum), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPublicKeyCredentialConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSPublicKeyCredentialConstructor) } },
    { "rawId", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPublicKeyCredentialRawId), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "response", static_cast<unsigned>(JSC::PropertyAttribute::ReadOnly | JSC::PropertyAttribute::CustomAccessor | JSC::PropertyAttribute::DOMAttribute), NoIntrinsic, { (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsPublicKeyCredentialResponse), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) } },
    { "getClientExtensionResults", static_cast<unsigned>(JSC::PropertyAttribute::Function), NoIntrinsic, { (intptr_t)static_cast<NativeFunction>(jsPublicKeyCredentialPrototypeFunctionGetClientExtensionResults), (intptr_t) (0) } },
};

const ClassInfo JSPublicKeyCredentialPrototype::s_info = { "PublicKeyCredentialPrototype", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPublicKeyCredentialPrototype) };

void JSPublicKeyCredentialPrototype::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    reifyStaticProperties(vm, JSPublicKeyCredential::info(), JSPublicKeyCredentialPrototypeTableValues, *this);
}

const ClassInfo JSPublicKeyCredential::s_info = { "PublicKeyCredential", &Base::s_info, nullptr, nullptr, CREATE_METHOD_TABLE(JSPublicKeyCredential) };

JSPublicKeyCredential::JSPublicKeyCredential(Structure* structure, JSDOMGlobalObject& globalObject, Ref<PublicKeyCredential>&& impl)
    : JSDOMWrapper<PublicKeyCredential>(structure, globalObject, WTFMove(impl))
{
}

void JSPublicKeyCredential::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(vm, info()));

}

JSObject* JSPublicKeyCredential::createPrototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return JSPublicKeyCredentialPrototype::create(vm, &globalObject, JSPublicKeyCredentialPrototype::createStructure(vm, &globalObject, globalObject.objectPrototype()));
}

JSObject* JSPublicKeyCredential::prototype(VM& vm, JSDOMGlobalObject& globalObject)
{
    return getDOMPrototype<JSPublicKeyCredential>(vm, globalObject);
}

JSValue JSPublicKeyCredential::getConstructor(VM& vm, const JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSPublicKeyCredentialConstructor>(vm, *jsCast<const JSDOMGlobalObject*>(globalObject));
}

void JSPublicKeyCredential::destroy(JSC::JSCell* cell)
{
    JSPublicKeyCredential* thisObject = static_cast<JSPublicKeyCredential*>(cell);
    thisObject->JSPublicKeyCredential::~JSPublicKeyCredential();
}

template<> inline JSPublicKeyCredential* IDLAttribute<JSPublicKeyCredential>::cast(ExecState& state, EncodedJSValue thisValue)
{
    return jsDynamicDowncast<JSPublicKeyCredential*>(state.vm(), JSValue::decode(thisValue));
}

template<> inline JSPublicKeyCredential* IDLOperation<JSPublicKeyCredential>::cast(ExecState& state)
{
    return jsDynamicDowncast<JSPublicKeyCredential*>(state.vm(), state.thisValue());
}

EncodedJSValue jsPublicKeyCredentialConstructor(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSPublicKeyCredentialPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype))
        return throwVMTypeError(state, throwScope);
    return JSValue::encode(JSPublicKeyCredential::getConstructor(state->vm(), prototype->globalObject()));
}

bool setJSPublicKeyCredentialConstructor(ExecState* state, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    VM& vm = state->vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    auto* prototype = jsDynamicDowncast<JSPublicKeyCredentialPrototype*>(vm, JSValue::decode(thisValue));
    if (UNLIKELY(!prototype)) {
        throwVMTypeError(state, throwScope);
        return false;
    }
    // Shadowing a built-in constructor
    return prototype->putDirect(vm, vm.propertyNames->constructor, JSValue::decode(encodedValue));
}

static inline JSValue jsPublicKeyCredentialRawIdGetter(ExecState& state, JSPublicKeyCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLArrayBuffer>(state, *thisObject.globalObject(), throwScope, impl.rawId());
    return result;
}

EncodedJSValue jsPublicKeyCredentialRawId(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSPublicKeyCredential>::get<jsPublicKeyCredentialRawIdGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "rawId");
}

static inline JSValue jsPublicKeyCredentialResponseGetter(ExecState& state, JSPublicKeyCredential& thisObject, ThrowScope& throwScope)
{
    UNUSED_PARAM(throwScope);
    UNUSED_PARAM(state);
    auto& impl = thisObject.wrapped();
    JSValue result = toJS<IDLInterface<AuthenticatorResponse>>(state, *thisObject.globalObject(), throwScope, impl.response());
    return result;
}

EncodedJSValue jsPublicKeyCredentialResponse(ExecState* state, EncodedJSValue thisValue, PropertyName)
{
    return IDLAttribute<JSPublicKeyCredential>::get<jsPublicKeyCredentialResponseGetter, CastedThisErrorBehavior::Assert>(*state, thisValue, "response");
}

static inline JSC::EncodedJSValue jsPublicKeyCredentialPrototypeFunctionGetClientExtensionResultsBody(JSC::ExecState* state, typename IDLOperation<JSPublicKeyCredential>::ClassParameter castedThis, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    auto& impl = castedThis->wrapped();
    return JSValue::encode(toJS<IDLBoolean>(*state, throwScope, impl.getClientExtensionResults()));
}

EncodedJSValue JSC_HOST_CALL jsPublicKeyCredentialPrototypeFunctionGetClientExtensionResults(ExecState* state)
{
    return IDLOperation<JSPublicKeyCredential>::call<jsPublicKeyCredentialPrototypeFunctionGetClientExtensionResultsBody>(*state, "getClientExtensionResults");
}

static inline JSC::EncodedJSValue jsPublicKeyCredentialConstructorFunctionIsUserVerifyingPlatformAuthenticatorAvailableBody(JSC::ExecState* state, Ref<DeferredPromise>&& promise, JSC::ThrowScope& throwScope)
{
    UNUSED_PARAM(state);
    UNUSED_PARAM(throwScope);
    PublicKeyCredential::isUserVerifyingPlatformAuthenticatorAvailable(WTFMove(promise));
    return JSValue::encode(jsUndefined());
}

EncodedJSValue JSC_HOST_CALL jsPublicKeyCredentialConstructorFunctionIsUserVerifyingPlatformAuthenticatorAvailable(ExecState* state)
{
    return IDLOperationReturningPromise<JSPublicKeyCredential>::callStatic<jsPublicKeyCredentialConstructorFunctionIsUserVerifyingPlatformAuthenticatorAvailableBody, PromiseExecutionScope::WindowOrWorker>(*state, "isUserVerifyingPlatformAuthenticatorAvailable");
}

bool JSPublicKeyCredentialOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSPublicKeyCredentialOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    auto* jsPublicKeyCredential = static_cast<JSPublicKeyCredential*>(handle.slot()->asCell());
    auto& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsPublicKeyCredential->wrapped(), jsPublicKeyCredential);
}

#if ENABLE(BINDING_INTEGRITY)
#if PLATFORM(WIN)
#pragma warning(disable: 4483)
extern "C" { extern void (*const __identifier("??_7PublicKeyCredential@WebCore@@6B@")[])(); }
#else
extern "C" { extern void* _ZTVN7WebCore19PublicKeyCredentialE[]; }
#endif
#endif

JSC::JSValue toJSNewlyCreated(JSC::ExecState*, JSDOMGlobalObject* globalObject, Ref<PublicKeyCredential>&& impl)
{

#if ENABLE(BINDING_INTEGRITY)
    void* actualVTablePointer = *(reinterpret_cast<void**>(impl.ptr()));
#if PLATFORM(WIN)
    void* expectedVTablePointer = reinterpret_cast<void*>(__identifier("??_7PublicKeyCredential@WebCore@@6B@"));
#else
    void* expectedVTablePointer = &_ZTVN7WebCore19PublicKeyCredentialE[2];
#endif

    // If this fails PublicKeyCredential does not have a vtable, so you need to add the
    // ImplementationLacksVTable attribute to the interface definition
    static_assert(std::is_polymorphic<PublicKeyCredential>::value, "PublicKeyCredential is not polymorphic");

    // If you hit this assertion you either have a use after free bug, or
    // PublicKeyCredential has subclasses. If PublicKeyCredential has subclasses that get passed
    // to toJS() we currently require PublicKeyCredential you to opt out of binding hardening
    // by adding the SkipVTableValidation attribute to the interface IDL definition
    RELEASE_ASSERT(actualVTablePointer == expectedVTablePointer);
#endif
    return createWrapper<PublicKeyCredential>(globalObject, WTFMove(impl));
}

JSC::JSValue toJS(JSC::ExecState* state, JSDOMGlobalObject* globalObject, PublicKeyCredential& impl)
{
    return wrap(state, globalObject, impl);
}

PublicKeyCredential* JSPublicKeyCredential::toWrapped(JSC::VM& vm, JSC::JSValue value)
{
    if (auto* wrapper = jsDynamicDowncast<JSPublicKeyCredential*>(vm, value))
        return &wrapper->wrapped();
    return nullptr;
}

}
