/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSPublicKeyCredentialCreationOptions.h"

#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSPublicKeyCredentialDescriptor.h"
#include "JSPublicKeyCredentialType.h"
#include <runtime/JSArray.h>
#include <runtime/JSCInlines.h>
#include <wtf/Variant.h>


namespace WebCore {
using namespace JSC;

template<> PublicKeyCredentialCreationOptions convertDictionary<PublicKeyCredentialCreationOptions>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    PublicKeyCredentialCreationOptions result;
    JSValue challengeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "challenge"));
    if (!challengeValue.isUndefined()) {
        result.challenge = convert<IDLUnion<IDLArrayBufferView, IDLArrayBuffer>>(state, challengeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "challenge", "PublicKeyCredentialCreationOptions", "(ArrayBufferView or ArrayBuffer)");
        return { };
    }
    JSValue excludeCredentialsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "excludeCredentials"));
    if (!excludeCredentialsValue.isUndefined()) {
        result.excludeCredentials = convert<IDLSequence<IDLDictionary<PublicKeyCredentialDescriptor>>>(state, excludeCredentialsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.excludeCredentials = Converter<IDLSequence<IDLDictionary<PublicKeyCredentialDescriptor>>>::ReturnType{ };
    JSValue pubKeyCredParamsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "pubKeyCredParams"));
    if (!pubKeyCredParamsValue.isUndefined()) {
        result.pubKeyCredParams = convert<IDLSequence<IDLDictionary<PublicKeyCredentialCreationOptions::Parameters>>>(state, pubKeyCredParamsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "pubKeyCredParams", "PublicKeyCredentialCreationOptions", "sequence");
        return { };
    }
    JSValue rpValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "rp"));
    if (!rpValue.isUndefined()) {
        result.rp = convert<IDLDictionary<PublicKeyCredentialCreationOptions::RpEntity>>(state, rpValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "rp", "PublicKeyCredentialCreationOptions", "PublicKeyCredentialRpEntity");
        return { };
    }
    JSValue timeoutValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "timeout"));
    if (!timeoutValue.isUndefined()) {
        result.timeout = convert<IDLUnsignedLong>(state, timeoutValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue userValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "user"));
    if (!userValue.isUndefined()) {
        result.user = convert<IDLDictionary<PublicKeyCredentialCreationOptions::UserEntity>>(state, userValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "user", "PublicKeyCredentialCreationOptions", "PublicKeyCredentialUserEntity");
        return { };
    }
    return result;
}

template<> PublicKeyCredentialCreationOptions::Entity convertDictionary<PublicKeyCredentialCreationOptions::Entity>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    PublicKeyCredentialCreationOptions::Entity result;
    JSValue iconValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "icon"));
    if (!iconValue.isUndefined()) {
        result.icon = convert<IDLUSVString>(state, iconValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue nameValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "name"));
    if (!nameValue.isUndefined()) {
        result.name = convert<IDLDOMString>(state, nameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "name", "PublicKeyCredentialEntity", "DOMString");
        return { };
    }
    return result;
}

template<> PublicKeyCredentialCreationOptions::RpEntity convertDictionary<PublicKeyCredentialCreationOptions::RpEntity>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    PublicKeyCredentialCreationOptions::RpEntity result;
    JSValue iconValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "icon"));
    if (!iconValue.isUndefined()) {
        result.icon = convert<IDLUSVString>(state, iconValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue nameValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "name"));
    if (!nameValue.isUndefined()) {
        result.name = convert<IDLDOMString>(state, nameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "name", "PublicKeyCredentialRpEntity", "DOMString");
        return { };
    }
    JSValue idValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "id"));
    if (!idValue.isUndefined()) {
        result.id = convert<IDLDOMString>(state, idValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

template<> PublicKeyCredentialCreationOptions::UserEntity convertDictionary<PublicKeyCredentialCreationOptions::UserEntity>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    PublicKeyCredentialCreationOptions::UserEntity result;
    JSValue iconValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "icon"));
    if (!iconValue.isUndefined()) {
        result.icon = convert<IDLUSVString>(state, iconValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue nameValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "name"));
    if (!nameValue.isUndefined()) {
        result.name = convert<IDLDOMString>(state, nameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "name", "PublicKeyCredentialUserEntity", "DOMString");
        return { };
    }
    JSValue displayNameValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "displayName"));
    if (!displayNameValue.isUndefined()) {
        result.displayName = convert<IDLDOMString>(state, displayNameValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "displayName", "PublicKeyCredentialUserEntity", "DOMString");
        return { };
    }
    JSValue idValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "id"));
    if (!idValue.isUndefined()) {
        result.id = convert<IDLUnion<IDLArrayBufferView, IDLArrayBuffer>>(state, idValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "id", "PublicKeyCredentialUserEntity", "(ArrayBufferView or ArrayBuffer)");
        return { };
    }
    return result;
}

template<> PublicKeyCredentialCreationOptions::Parameters convertDictionary<PublicKeyCredentialCreationOptions::Parameters>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    PublicKeyCredentialCreationOptions::Parameters result;
    JSValue algValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "alg"));
    if (!algValue.isUndefined()) {
        result.alg = convert<IDLLong>(state, algValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "alg", "PublicKeyCredentialParameters", "long");
        return { };
    }
    JSValue typeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "type"));
    if (!typeValue.isUndefined()) {
        result.type = convert<IDLEnumeration<PublicKeyCredentialType>>(state, typeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "type", "PublicKeyCredentialParameters", "PublicKeyCredentialType");
        return { };
    }
    return result;
}

} // namespace WebCore
