/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSPublicKeyCredentialDescriptor.h"

#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertUnion.h"
#include "JSPublicKeyCredentialType.h"
#include <runtime/JSCInlines.h>
#include <wtf/Variant.h>


namespace WebCore {
using namespace JSC;

template<> PublicKeyCredentialDescriptor convertDictionary<PublicKeyCredentialDescriptor>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    PublicKeyCredentialDescriptor result;
    JSValue idValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "id"));
    if (!idValue.isUndefined()) {
        result.id = convert<IDLUnion<IDLArrayBufferView, IDLArrayBuffer>>(state, idValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "id", "PublicKeyCredentialDescriptor", "(ArrayBufferView or ArrayBuffer)");
        return { };
    }
    JSValue typeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "type"));
    if (!typeValue.isUndefined()) {
        result.type = convert<IDLEnumeration<PublicKeyCredentialType>>(state, typeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "type", "PublicKeyCredentialDescriptor", "PublicKeyCredentialType");
        return { };
    }
    return result;
}

} // namespace WebCore
