/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSPublicKeyCredentialRequestOptions.h"

#include "JSDOMConvertBufferSource.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSDOMConvertUnion.h"
#include "JSPublicKeyCredentialDescriptor.h"
#include <runtime/JSArray.h>
#include <runtime/JSCInlines.h>
#include <wtf/Variant.h>


namespace WebCore {
using namespace JSC;

template<> PublicKeyCredentialRequestOptions convertDictionary<PublicKeyCredentialRequestOptions>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    PublicKeyCredentialRequestOptions result;
    JSValue allowCredentialsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "allowCredentials"));
    if (!allowCredentialsValue.isUndefined()) {
        result.allowCredentials = convert<IDLSequence<IDLDictionary<PublicKeyCredentialDescriptor>>>(state, allowCredentialsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.allowCredentials = Converter<IDLSequence<IDLDictionary<PublicKeyCredentialDescriptor>>>::ReturnType{ };
    JSValue challengeValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "challenge"));
    if (!challengeValue.isUndefined()) {
        result.challenge = convert<IDLUnion<IDLArrayBufferView, IDLArrayBuffer>>(state, challengeValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(state, throwScope, "challenge", "PublicKeyCredentialRequestOptions", "(ArrayBufferView or ArrayBuffer)");
        return { };
    }
    JSValue rpIdValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "rpId"));
    if (!rpIdValue.isUndefined()) {
        result.rpId = convert<IDLUSVString>(state, rpIdValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue timeoutValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "timeout"));
    if (!timeoutValue.isUndefined()) {
        result.timeout = convert<IDLUnsignedLong>(state, timeoutValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

} // namespace WebCore
