/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSVRLayerInit.h"

#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNullable.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMGlobalObject.h"
#include "JSHTMLCanvasElement.h"
#include <runtime/JSArray.h>
#include <runtime/JSCInlines.h>
#include <runtime/ObjectConstructor.h>


namespace WebCore {
using namespace JSC;

template<> VRLayerInit convertDictionary<VRLayerInit>(ExecState& state, JSValue value)
{
    VM& vm = state.vm();
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&state, throwScope);
        return { };
    }
    VRLayerInit result;
    JSValue leftBoundsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "leftBounds"));
    if (!leftBoundsValue.isUndefined()) {
        result.leftBounds = convert<IDLSequence<IDLFloat>>(state, leftBoundsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.leftBounds = Converter<IDLSequence<IDLFloat>>::ReturnType{ };
    JSValue rightBoundsValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "rightBounds"));
    if (!rightBoundsValue.isUndefined()) {
        result.rightBounds = convert<IDLSequence<IDLFloat>>(state, rightBoundsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.rightBounds = Converter<IDLSequence<IDLFloat>>::ReturnType{ };
    JSValue sourceValue = isNullOrUndefined ? jsUndefined() : object->get(&state, Identifier::fromString(&state, "source"));
    if (!sourceValue.isUndefined()) {
        result.source = convert<IDLNullable<IDLInterface<HTMLCanvasElement>>>(state, sourceValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else
        result.source = nullptr;
    return result;
}

JSC::JSObject* convertDictionaryToJS(JSC::ExecState& state, JSDOMGlobalObject& globalObject, const VRLayerInit& dictionary)
{
    auto& vm = state.vm();

    auto result = constructEmptyObject(&state, globalObject.objectPrototype());

    auto leftBoundsValue = toJS<IDLSequence<IDLFloat>>(state, globalObject, dictionary.leftBounds);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "leftBounds"), leftBoundsValue);
    auto rightBoundsValue = toJS<IDLSequence<IDLFloat>>(state, globalObject, dictionary.rightBounds);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "rightBounds"), rightBoundsValue);
    auto sourceValue = toJS<IDLNullable<IDLInterface<HTMLCanvasElement>>>(state, globalObject, dictionary.source);
    result->putDirect(vm, JSC::Identifier::fromString(&vm, "source"), sourceValue);
    return result;
}

} // namespace WebCore
